#include <iostream>
#include<cmath>

using std::cout;
using std::cerr;
using std::endl;
using std::cin;

double getNext(double uNm1, double uNm2) {
  return uNm1+1./uNm2;
}

int main () 
{
  double u0,u1,u2; 
  int    choice,n;

  u0 = 1.;
  u1 = 3.;

  cout << "What would you like ?"                << endl
       << "1. Compute sum of sequence"           << endl
       << "2. Display sequence"                  << endl
       << "3. Determine rank for cumulative sum" << endl
       << "> ";
  cin  >> choice;

  switch (choice) {

    case 1: {
      int n;
      cout << "How many terms ?" << endl << "> ";
      cin  >> n;
      cout << "Result:";
      switch (n) {
        case 0: cout << 0.    << endl; break;
        case 1: cout << u0    << endl; break;
        case 2: cout << u0+u1 << endl; break;
        default: {
          double sum = 0., u2;
          for (unsigned int i=0u; i<n; i++) {
            u2   = getNext(u1,u0);
            sum += u2;
            u0   = u1;
            u1   = u2;
          }
          cout << sum << endl;
        }
      }
      break;
    }

    case 2: {
      int n;
      cout << "How many terms ?" << endl << "> ";
      cin  >> n;
      if (n>0) cout << u0 << " ";
      if (n>1) cout << u1 << " ";
      double u2;
      for (unsigned int i=0u; i<n; i++) {
        u2   = getNext(u1,u0);
        cout << u2 << " ";
        u0   = u1;
        u1   = u2;
      }
      cout << endl;
      break;
    }

    case 3: {
      double max;
      cout << "Which quantity to exceed ?" << endl << "> ";
      cin  >> max;
      cout << "Number of terms: ";
      if (u0>max) 
        cout << 1 << " and sum is " << 0 << endl;
      else if (u0+u1>max) 
        cout << 2 << " and sum is " << u0 << endl;
      else {
        int    n   = 2;
        double sum = u0+u1;
        double u2;
        do {
          u2   = getNext(u1,u0);
          sum += u2;
          u0   = u1;
          u1   = u2;
          n++;
        } while (sum<max);
        cout << n << " and sum is " << sum << endl;
      }
      break;
    }

    default:
      cerr << "Wrong input" << endl;
      exit(0);
  }
  
  return 0;

}
 



